local Proxy = module("vrp", "lib/Proxy")
local Tunnel = module("vrp", "lib/Tunnel")

local vRP = Proxy.getInterface("vRP")
local vRPclient = Tunnel.getInterface("vRP", "sx_mdt")

vRPmdt = {}
Tunnel.bindInterface("sx_mdt", vRPmdt)
Proxy.addInterface("sx_mdt", vRPmdt)

mdtClient = Tunnel.getInterface("mdtClient","mdtClient");

local playerIdentities = {};
local userSources = {};
local mandateActive = {};
local reports = {};

local calls = {};	-- ce telelfon ai bosule? qb? da

function initPlayer(user_id, player)
	playerIdentities[user_id] = {};
	userSources[user_id] = player;

	vRP.getUserIdentity{user_id, function(identity)
		if identity then
			playerIdentities[user_id].firstname = identity.firstName;
			playerIdentities[user_id].name = identity.secondName;
		end
	end}
	print(userSources[user_id], json.encode(playerIdentities[user_id]))
end

exports("getPolice",function()
	return userSources;
end)

CreateThread(function()
	print("^5[MDT] ^0Acest ^4M^2D^1T^0 a fost realizat de catre ^2s^5x^4i^5n^5t^7c^8o^9a^1i^2e^5#^46^59^56^79^0");
	Wait(1000)
	local q = exports.oxmysql:querySync("SELECT * FROM (SELECT * FROM `mdt_warrants` ORDER BY `id` DESC LIMIT 3) sub ORDER BY `id` DESC");
	if #q > 0 and q[1] then
		for _,v in pairs(q) do
			mandateActive[#mandateActive+1] = {
				id = v.id,
				name = v.name,
				char_id = v.char_id,
				report_id = v.report_id,
				report_title = v.report_title,
				charges = json.decode(v.charges),
				date = v.date,
				expire = v.expire,
				notes = v.notes,
				author = v.author,

			};
		end;
	end

	local r = exports.oxmysql:querySync("SELECT * FROM (SELECT * FROM `mdt_reports` ORDER BY `id` DESC LIMIT 3) sub ORDER BY `id` DESC");
	if #r > 0 and r[1] then
		for _,v in pairs(r) do
			reports[#reports+1] = {
				id = v.id,
				char_id = v.char_id,
				title = v.title,
				incident = v.incident,
				charges = json.decode(v.charges),
				author = v.author,
				name = v.name,
				date = v.date,
			};
		end;
	end;

	for _,v in pairs(GetPlayers()) do
		local user_id = vRP.getUserId{v};
		if user_id and (vRP.isUserInFaction{user_id, "Politie"}) then
			initPlayer(user_id, v);			
		end
	end
end)

AddEventHandler('onFactionChanged',function(user_id, faction, removed)
	if faction == "Politie" then
		if not removed then
			initPlayer(user_id, vRP.getUserSource{user_id})
		else
			playerIdentities[user_id] = nil;
			userSources[user_id] = nil;
		end
	else
		if playerIdentities[user_id] then
			playerIdentities[user_id] = nil;
		end;
		if userSources[user_id] then
			userSources[user_id] = nil;
		end;
	end
end);

AddEventHandler('vRP:playerSpawn',function(user_id, player, fs) -- PLAYER SPAWN EVENT
	if fs and (vRP.isUserInFaction{user_id, "Politie"}) then
		initPlayer(user_id, player)
	end
end);

AddEventHandler('vRP:playerLeave',function(user_id) -- PLAYER LEAVE EVENT
	if playerIdentities[user_id] or userSources[user_id] then
		playerIdentities[user_id] = nil;
		userSources[user_id] = nil;
	end;
end)

function getOfficerName(user_id)
	if playerIdentities[user_id] then
		return (playerIdentities[user_id].firstname.. " " ..playerIdentities[user_id].name);
	end;
	return "";
end;

function GetOfficerRankandName(source)
	local user_id = vRP.getUserId{source};
	if user_id and playerIdentities[user_id] then
		return vRP.getFactionRank{user_id}.." | "..playerIdentities[user_id].firstname.." "..playerIdentities[user_id].name;
	end;
	return nil;
end;

function vRPmdt._getOffensesAndOfficer()
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and (vRP.isUserInFaction{user_id, "Politie"}) then	
		local offName =	GetOfficerRankandName(source);
		if offName then
			TriggerClientEvent('mdt:returnOffensesAndOfficer', player, _, offName);
		end
	end
end

function vRPmdt._hotKeyOpen()
    local player = source
    local user_id = vRP['getUserId']{player}
    
    if user_id then
        if vRP.isUserInFaction{user_id, "Politie"} then
            -- Verifică dacă există în playerIdentities înainte de a accesa
            local officer = ""
            if playerIdentities[user_id] then
                officer = vRP.getFactionRank{user_id}.." | "..playerIdentities[user_id].firstname.." "..playerIdentities[user_id].name
            else
                officer = "Informații indisponibile"
            end

            TriggerClientEvent('mdt:toggleVisibilty', player, reports, mandateActive, officer, true)
        end
    end
end

RegisterServerEvent("mdt:performOffenderSearch",function(query)
	if query then
		local player = source
		local user_id = vRP.getUserId{player};
		
		if user_id and userSources[user_id] then
			local matches = {};
			local fullName = splitString(tostring(query), " ");
			if #fullName > 1 then
				if (string.len(fullName[1]) < 3 and string.len(fullName[2]) < 3) then return vRPclient.notify(player, {"Numele trebuie sa contina peste 3 caractere!"}) end;
				sqlString = "SELECT * FROM vrp_users WHERE firstName LIKE '%"..fullName[1].."%' or secondName LIKE '%"..fullName[2].."%'";
			else
				if (string.len(fullName[1]) < 3) then return vRPclient.notify(player, {"Numele trebuie sa contina peste 3 caractere!"}) end;
				sqlString = "SELECT * FROM vrp_users WHERE firstName LIKE '%"..fullName[1].."%'";
			end;

			exports.oxmysql:query(sqlString,{},function(result)
				if #result > 0 and result[1] then
					for i=1, #result do
						local identityTable = {
							firstName = result[i].firstName,
							lastName = result[i].secondName,
							age = result[i].age or 0,
						}
						-- local identityTable = json.decode(result[i].userIdentity);
						-- local uReports = json.decode(result[i].userCazier or '[]') or {}
						matches[#matches+1] = {
							firstname = identityTable.firstName;
							lastname = identityTable.lastName; 
							dateofbirth = identityTable.age;
							caziere = 0;
							id = result[i].id;
						};
					end;
					TriggerClientEvent('mdt:returnOffenderSearchResults', player, matches);
					return;
				else
					exports.oxmysql:query("SELECT user_id FROM vrp_user_vehicles WHERE vehicle_plate LIKE ?",{'%'..query..'%'},function(result)
						if #result > 0 and result[1] then
							exports.oxmysql:query("SELECT * FROM vrp_users WHERE id = ?",{result[1].user_id},function(rows)
								if #rows > 0 and rows[1] then
									for i=1,#rows do
										local data = {
											firstName = rows[i].firstName,
											lastName = rows[i].secondName,
											age = rows[i].age,
										}
										-- local data = json.decode(rows[i].userIdentity);
										-- local uReports = json.decode(rows[i].userCazier or '[]') or {};
										matches[#matches+1] = {
											firstname = data.firstName;
											lastname = data.lastName;
											dateofbirth = data.age;
											caziere = 0;
											id = rows[i].id;
										};
									end
									TriggerClientEvent('mdt:returnOffenderSearchResults', player, matches);
									return;
								end
							end)
						end
					end)
				end
			end)
			TriggerClientEvent('mdt:returnOffenderSearchResults', player, {});
		end
	end
end)

RegisterServerEvent("mdt:getOffenderDetails", function(offender)
	if not offender then return end;
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] then
		local result = exports.oxmysql:querySync("SELECT * FROM user_mdt WHERE char_id = ?",{offender.id});

		offender.notes = result?[1]?['notes'] or ""
		offender.mugshot_url = result?[1]?['mugshot_url'] or ""
		offender.bail = result?[1]?['bail'] or false

		local convictions = exports.oxmysql:querySync("SELECT * FROM user_convictions WHERE char_id = ?",{offender.id});
		if #convictions > 0 and convictions[1] then
			offender.convictions = {}
			for i = 1, #convictions do
				local conviction = convictions[i]
				offender.convictions[conviction.offense] = conviction.count
			end
		end

		local qbphone = exports.phone:getPhoneNumber(offender.id)
		-- local p = promise.new()
		-- vRP.getUserPhone({offender.id, function(phone)
		-- 	p:resolve(phone)
		-- end});
		-- local phone = Citizen.Await(p)

		offender.phone_number = phone;
		for i=1, #mandateActive do
			if mandateActive[i].char_id == user_id then
				offender.haswarrant = true;
			end;
		end;

		TriggerClientEvent("mdt:returnOffenderDetails", player, offender)
	end
end)

RegisterServerEvent("mdt:getOffenderDetailsById",function(char_id)
	if not char_id then return end;
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] then -- "SELECT * FROM vrp_user_ids INNER JOIN vrp_users ON vrp_user_ids.identifier = @identifier AND vrp_users.id = vrp_user_ids.user_id;"
		local result = exports.oxmysql:querySync("SELECT char_id,notes,mugshot_url,bail,firstName,secondName,age FROM user_mdt INNER JOIN vrp_users ON user_mdt.char_id = ? AND vrp_users.id = user_mdt.char_id",{char_id})

		-- print(json.encode(result))

		local offender = {};
		offender.notes = result?[1]?['notes'] or ""
		offender.mugshot_url = result?[1]?['mugshot_url'] or ""
		offender.bail = result?[1]?['bail'] or false

		local convictions = exports.oxmysql:querySync("SELECT * FROM user_convictions WHERE char_id = ?",{char_id});
		if #convictions > 0 and convictions[1] then
			offender.convictions = {}
			for i = 1, #convictions do
				local conviction = convictions[i]
				offender.convictions[conviction.offense] = conviction.count
			end
		end

		-- local p = promise.new()
		-- vRP.getUserPhone({char_id, function(x)
			-- p:resolve(x)
		-- end})
		local phone_number = exports.phone:getPhoneNumber(char_id)
		-- local caziere = json.decode(result?[1]?.userCazier or '[]') or {}
		local identity = {
			firstName = result[1].firstName or "",
			lastName = result[1].lastName or "",
			age = result[1].age or ""
		}
		-- local identity = json.decode(result?[1]?.userIdentity or '[]') or {};
		offender.firstname = identity.firstName;
		offender.lastname = identity.lastName;
		offender.dateofbirth = identity.age;
		offender.phone_number = phone_number;
		offender.caziere = 0
		-- offender.caziere = table.len(caziere) or 0
		for i=1, #mandateActive do
			if mandateActive[i].char_id == user_id then
				offender.haswarrant = true;
			end;
		end;

		TriggerClientEvent("mdt:returnOffenderDetails", player, offender)
	end
end)

RegisterServerEvent('mdt:saveOffenderChanges', function(target_id, changes, identifier)
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] and next(changes) then
		local qsync = exports.oxmysql:querySync("SELECT * FROM user_mdt WHERE char_id = ?",{target_id})
		if #qsync > 0 and qsync[1] then
			exports.oxmysql:query("UPDATE user_mdt SET notes = ?, mugshot_url = ?, bail = ? WHERE char_id = ?",{ changes.notes, changes.mugshot_url, changes.bail, target_id });
		else
			exports.oxmysql:query("INSERT INTO user_mdt(char_id,notes,mugshot_url,bail) VALUES(@char_id, @notes, @mugshot_url, @bail)",{
				['@char_id'] = target_id,
				['@notes'] = changes.notes,
				['@mugshot_url'] = changes.mugshot_url,
				['@bail'] = changes.bail,
			});
		end

		if changes.convictions ~= nil then
			for conviction, amount in pairs(changes.convictions) do	
				exports.oxmysql:query('UPDATE `user_convictions` SET `count` = @count WHERE `char_id` = @identifier AND `offense` = @offense', {
					['@identifier'] = target_id,
					['@count'] = amount,
					['@offense'] = conviction
				})
			end
		end

		if #changes.convictions_removed > 0 then
			for i = 1, #changes.convictions_removed do
				exports.oxmysql:query('DELETE FROM `user_convictions` WHERE `char_id` = @identifier AND `offense` = @offense', {
					['@identifier'] = target_id,
					['offense'] = changes.convictions_removed[i]
				})
			end
		end

		TriggerClientEvent("mdt:sendNotification", player, "Offender changes have been saved.")
	end
end)



RegisterServerEvent("mdt:saveReportChanges",function(data)
	if next(data) then
		local player = source;
		local user_id = vRP.getUserId{player};
		if user_id and userSources[user_id] then
			exports.oxmysql:query('UPDATE `mdt_reports` SET `title` = @title, `incident` = @incident WHERE `id` = @identifier', {
				['@identifier'] = data.identifier,
				['@title'] = data.title,
				['@incident'] = data.incident
			})
			for i=1, #reports do
				if reports[i].char_id == identifier then
					reports[i].title = data.title;
					reports[i].incident = data.incident;
					break
				end;
			end;
			TriggerClientEvent("mdt:sendNotification", player, "Report changes have been saved.")
		end
	end
end)



RegisterServerEvent("mdt:deleteReport", function(char_id)
	if char_id then
		local player = source;
		local user_id = vRP.getUserId{player};
		if user_id and userSources[user_id] then
			exports.oxmysql:query("DELETE FROM mdt_reports WHERE id = ?",{char_id});
			for i=1, #reports do
				if reports[i].char_id == char_id then
					reports[i] = nil;
					break;
				end;
			end;
			TriggerClientEvent("mdt:sendNotification", player, "Report has been successfully deleted.")
		end
	end
end)

RegisterServerEvent("mdt:submitNewReport",function(data)
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] then
		local author = playerIdentities[user_id].firstname.." "..playerIdentities[user_id].name;
		local charges = json.encode(data.charges);
		data.date = os.date("%m-%d-%Y %H:%M:%S", os.time());
		exports.oxmysql:query("INSERT INTO mdt_reports(char_id, title, incident, charges, author, name, date) VALUES(@char_id, @title, @incident, @charges, @author, @name, @date)",{
			['@char_id'] = data.char_id,
			['@title'] = data.title,
			['@incident'] = data.incident,
			['@charges'] = charges,
			['@author'] = author,
			['@name'] = data.name,
			['@date'] = data.date,
		}, function(rows)
			if rows.insertId then
				local index = #reports+1;
				reports[index] = {
					char_id = data.char_id,
					title = data.title,
					incident = data.incident,
					charges = json.decode(charges),
					author = author,
					name = data.name,
					date = data.date,
				};
				TriggerEvent("mdt:getReportDetailsById", rows.insertId, reports[index], player)
				TriggerClientEvent("mdt:sendNotification", player, "A new report has been submitted.")
			end
		end);

		for offense, count in pairs(data.charges) do
			exports.oxmysql:query("REPLACE INTO user_convictions(char_id,offense,count) VALUES(@user_id,@offense,@count)",{
				['@user_id'] = data.char_id,
				['@offense'] = offense,
				['@count'] = count + 1,
			});
		end
	end
end)

RegisterServerEvent('mdt:performReportSearch',function(query)
	if query then
		local player = source;
		local user_id = vRP.getUserId{player};
		if user_id and userSources[user_id] then
			local matches = {}
			for i=1 , #reports do
				local index = #matches+1;
				if string.find(string.lower(reports[i].name), string.lower(query)) then
					matches[index] = reports[i];
				end

				if string.find(string.lower(reports[i].author), string.lower(query)) then
					matches[index] = reports[i];
				end
			end;
			TriggerClientEvent("mdt:returnReportSearchResults", player, matches)
			-- exports.oxmysql:query("SELECT * FROM `mdt_reports` WHERE `id` LIKE @query OR LOWER(`title`) LIKE @query OR LOWER(`name`) LIKE @query OR LOWER(`author`) LIKE @query or LOWER(`charges`) LIKE @query", {
			-- 	['@query'] = string.lower('%'..query..'%') -- % wildcard, needed to search for all alike results
			-- }, function(result)
			-- 	if #result > 0 and result[1] then
			-- 		for index, data in ipairs(result) do
			-- 			data.charges = json.decode(data.charges)
			-- 			matches[#matches+1] = data;
			-- 		end
			-- 	end

			-- 	TriggerClientEvent("mdt:returnReportSearchResults", player, matches)
			-- end)
		end
	end
end)

RegisterServerEvent("mdt:performVehicleSearch")
AddEventHandler("mdt:performVehicleSearch", function(query)
	-- local usource = source
	-- local matches = {}
	-- MySQL.Async.fetchAll("SELECT * FROM `owned_vehicles` WHERE LOWER(`plate`) LIKE @query", {
	-- 	['@query'] = string.lower('%'..query..'%') -- % wildcard, needed to search for all alike results
	-- }, function(result)

	-- 	for index, data in ipairs(result) do
	-- 		local data_decoded = json.decode(data.vehicle)
	-- 		data.model = data_decoded.model
	-- 		if data_decoded.color1 then
	-- 			data.color = colors[tostring(data_decoded.color1)]
	-- 			if colors[tostring(data_decoded.color2)] then
	-- 				data.color = colors[tostring(data_decoded.color2)] .. " on " .. colors[tostring(data_decoded.color1)]
	-- 			end
	-- 		end
	-- 		table.insert(matches, data)
	-- 	end

	-- 	TriggerClientEvent("mdt:returnVehicleSearchResults", usource, matches)
	-- end)
	TriggerClientEvent("mdt:returnVehicleSearchResults", source, {}) -- WIP
end)

RegisterServerEvent("mdt:performVehicleSearchInFront")
AddEventHandler("mdt:performVehicleSearchInFront", function(query)
	-- local usource = source
	-- local xPlayer = ESX.GetPlayerFromId(usource)
    -- if xPlayer.job.name == 'police' then
    -- 	MySQL.Async.fetchAll("SELECT * FROM (SELECT * FROM `mdt_reports` ORDER BY `id` DESC LIMIT 3) sub ORDER BY `id` DESC", {}, function(reports)
    -- 		for r = 1, #reports do
    -- 			reports[r].charges = json.decode(reports[r].charges)
    -- 		end
    -- 		MySQL.Async.fetchAll("SELECT * FROM (SELECT * FROM `mdt_warrants` ORDER BY `id` DESC LIMIT 3) sub ORDER BY `id` DESC", {}, function(warrants)
    -- 			for w = 1, #warrants do
    -- 				warrants[w].charges = json.decode(warrants[w].charges)
    -- 			end
    -- 			MySQL.Async.fetchAll("SELECT * FROM `owned_vehicles` WHERE `plate` = @query", {
	-- 				['@query'] = query
	-- 			}, function(result)
	-- 				local officer = GetCharacterName(usource)
    -- 				TriggerClientEvent('mdt:toggleVisibilty', usource, reports, warrants, officer, xPlayer.job.name)
	-- 				TriggerClientEvent("mdt:returnVehicleSearchInFront", usource, result, query)
	-- 			end)
    -- 		end)
    -- 	end)
	-- end
	print("Acest event este momentan dezactivat - WIP #1")
end)

RegisterServerEvent("mdt:getVehicle")
AddEventHandler("mdt:getVehicle", function(vehicle)
	-- local usource = source
	-- local vresult = MySQL.Sync.fetchAll("SELECT * FROM `owned_vehicles` WHERE `plate` = @plate", {
	-- 	['@plate'] = vehicle.plate
	-- })
	-- if vresult[1] then
	-- 	vehicle.insured = vresult[1].insurance
	-- end
	-- local result = MySQL.Sync.fetchAll("SELECT * FROM `users` WHERE `identifier` = @query", {
	-- 	['@query'] = vehicle.owner
	-- })
	-- if result[1] then
	-- 	vehicle.owner = result[1].firstname .. ' ' .. result[1].lastname
	-- 	vehicle.owner_id = result[1].identifier
	-- end

	-- local data = MySQL.Sync.fetchAll('SELECT * FROM `vehicle_mdt` WHERE `plate` = @plate', {
	-- 	['@plate'] = vehicle.plate
	-- })
	-- if data[1] then
	-- 	if data[1].stolen == 1 then vehicle.stolen = true else vehicle.stolen = false end
	-- 	if data[1].notes ~= null then vehicle.notes = data[1].notes else vehicle.notes = '' end
	-- else
	-- 	vehicle.stolen = false
	-- 	vehicle.notes = ''
	-- end

	-- local warrants = MySQL.Sync.fetchAll('SELECT * FROM `mdt_warrants` WHERE `char_id` = @identifier', {
	-- 	['@identifier'] = vehicle.owner_id
	-- })
	-- if warrants[1] then
	-- 	vehicle.haswarrant = true
	-- end

	-- local bail = MySQL.Sync.fetchAll('SELECT `bail` FROM user_mdt WHERE `char_id` = @identifier', {
	-- 	['@identifier'] = vehicle.owner_id
	-- })
	-- if bail and bail[1] and bail[1].bail == 1 then vehicle.bail = true else vehicle.bail = false end

	-- vehicle.type = types[vehicle.type]
	-- TriggerClientEvent("mdt:returnVehicleDetails", usource, vehicle)
	print("Acest event este momentan dezactivat - WIP #2")
end)

RegisterServerEvent("mdt:getWarrants")
AddEventHandler("mdt:getWarrants", function()
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] then
		TriggerClientEvent("mdt:returnWarrants", player, mandateActive)
	end
end)

RegisterServerEvent("mdt:submitNewWarrant")
AddEventHandler("mdt:submitNewWarrant", function(data)
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] and playerIdentities[user_id] then
		if next(data) then
			data.author = playerIdentities[user_id].firstname.. " " .. playerIdentities[user_id].name;
			data.date = os.date("%m-%d-%Y %H:%M:%S", os.time());
			
			exports.oxmysql:query('INSERT INTO `mdt_warrants` (`name`, `char_id`, `report_id`, `report_title`, `charges`, `date`, `expire`, `notes`, `author`) VALUES (@name, @char_id, @report_id, @report_title, @charges, @date, @expire, @notes, @author)', {
				['@name']  = data.name,
				['@char_id'] = data.char_id,
				['@report_id'] = data.report_id,
				['@report_title'] = data.report_title,
				['@charges'] = json.encode(data.charges),
				['@date'] = data.date,
				['@expire'] = data.expire,
				['@notes'] = data.notes,
				['@author'] = data.author
			}, function(rows)
				local indexWarrant = #mandateActive+1;
				mandateActive[indexWarrant] = data;
				mandateActive[indexWarrant].id = rows.insertId;
				TriggerClientEvent("mdt:completedWarrantAction", player)
				TriggerClientEvent("mdt:sendNotification", player, "Mandatul cu numarul "..indexWarrant.." a fost creat.");
			end);
		end
	end
end);

RegisterServerEvent("mdt:deleteWarrant")
AddEventHandler("mdt:deleteWarrant", function(identifier)
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] then
		exports.oxmysql:query("DELETE FROM mdt_warrants WHERE id = ?",{identifier},function()
			for i=1, #mandateActive do
				if mandateActive[i].id == identifier then
					mandateActive[i] = nil;
					break;
				end;
			end;

			TriggerClientEvent("mdt:completedWarrantAction", player)
			TriggerClientEvent("mdt:sendNotification", player, "Mandatul a fost sters cu succes!");
		end)
	end
end)

RegisterServerEvent("mdt:getReportDetailsById")
AddEventHandler("mdt:getReportDetailsById", function(query, report, _source)
	if _source then source = _source end;
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] then
		if table.notEmpty(report) then
			TriggerClientEvent("mdt:returnReportDetails", player, report)
		else
			exports.oxmysql:query("SELECT * FROM mdt_reports WHERE id = @query",{['@query'] = query},function(result)
				if #result > 0 and result[1] then
					result[1].charges = json.decode(result[1].charges);
					TriggerClientEvent("mdt:returnReportDetails", player, result[1])
				else
					TriggerClientEvent("mdt:closeModal", player)
					TriggerClientEvent("mdt:sendNotification", player, "Acest raport nu a putut fi gasit.")
				end
			end)
		end
	end
end)

RegisterServerEvent("mdt:newCall")
AddEventHandler("mdt:newCall", function(data)
	if table.notEmpty(data) then
		for _,v in pairs(calls) do
			if v.user_id == data.user_id then
				return vRPclient.notify(data.source, {"Deja ai un apel in asteptare..."});
			end
		end
		-- local player = source;
		-- local user_id = vRP.getUserId{player};
		-- for _,v in pairs(calls or {}) do
		-- 	if v.user_id == user_id then
		-- 		return vRPclient.notify(player, {"Deja ai un apel in asteptare..."}) ;
		-- 	end;
		-- end;
		print(data.user_id)
		local index = #calls+1;
		calls[index] = {
			id = index,
			details = data.reason,
			caller = data.phoneNumber,
			coords = data.coords,
			user_id = data.user_id,
			source = data.source,
		};

		for _,v in pairs(userSources) do
			TriggerClientEvent('mdt:newCall', v, calls[index].details, calls[index].caller, calls[index].coords, index);
			vRPclient.notify(v, {"[MDT]: Un apel nou a fost facut!"});
		end
	end
end)

RegisterServerEvent("mdt:attachToCall")
AddEventHandler("mdt:attachToCall", function(index)
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] then
		local index = parseInt(index)
		if calls[index] then
			for _,v in pairs(userSources) do
				TriggerClientEvent("mdt:newCallAttach", v, index, getOfficerName(user_id))
			end

			TriggerClientEvent("mdt:sendNotification", player, "You have attached to this call.")
		end
	end
end)

RegisterServerEvent("mdt:detachFromCall")
AddEventHandler("mdt:detachFromCall", function(index)
	local player = source;
	local user_id = vRP.getUserId{player};
	if userSources[user_id] and playerIdentities[user_id] then
		local index = parseInt(index);
		if calls[index] then
			for _,v in pairs(userSources) do
				TriggerClientEvent('mdt:newCallDetach', v, index, getOfficerName(user_id));
			end
			TriggerClientEvent("mdt:sendNotification", player, "You have detached from this call.")
		end
	end
end);

AddEventHandler('vRP:playerLeave',function(user_id)
	for k,v in pairs(calls) do
		if v.user_id == user_id then
			calls[k] = nil;
			for _,v in pairs(userSources) do
				TriggerClientEvent('mdt:deleteCall', v, k);
			end
			break;
		end
	end
end)

RegisterServerEvent("mdt:editCall")
AddEventHandler("mdt:editCall", function(index, details)
	local player = source;
	local user_id = vRP.getUserId{player};
	if user_id and userSources[user_id] then
		if calls[index] then
			calls[index].details = details;
			for _,v in pairs(userSources) do
				TriggerClientEvent("mdt:editCall", v, index, details)
			end
			TriggerClientEvent("mdt:sendNotification", player, "You have edited this call.")
		end
	end

	-- local usource = source
	-- local xPlayers = ESX.GetPlayers()
	-- for i= 1, #xPlayers do
	-- 	local source = xPlayers[i]
	-- 	local xPlayer = ESX.GetPlayerFromId(source)
	-- 	if xPlayer.job.name == 'police' then
	-- 		TriggerClientEvent("mdt:editCall", source, index, details)
	-- 	end
	-- end
	-- TriggerClientEvent("mdt:sendNotification", usource, "You have edited this call.")
	-- print("Acest event a fost dezactivat temporar - WIP #7")
end)

RegisterServerEvent("mdt:deleteCall")
AddEventHandler("mdt:deleteCall", function(index)
	local player = source;
	local user_id = vRP.getUserId{player};
	local index = parseInt(index);
	if user_id and userSources[user_id] then
		if calls[index] then
			TriggerEvent("removeApelSpam", calls[index].source)
			
			calls[index] = nil;
			for _,v in pairs(userSources) do
				TriggerClientEvent('mdt:deleteCall', v, index);
			end

			TriggerClientEvent('mdt:sendNotification', player, "Ai sters acest apel!");
		end
	end
	-- local usource = source
	-- local xPlayers = ESX.GetPlayers()
	-- for i= 1, #xPlayers do
	-- 	local source = xPlayers[i]
	-- 	local xPlayer = ESX.GetPlayerFromId(source)
	-- 	if xPlayer.job.name == 'police' then
	-- 		TriggerClientEvent("mdt:deleteCall", source, index)
	-- 	end
	-- end
	-- TriggerClientEvent("mdt:sendNotification", usource, "You have deleted this call.")
	-- print("Acest event a fost dezactivat temporar - WIP #8")
end)

RegisterServerEvent("mdt:saveVehicleChanges")
AddEventHandler("mdt:saveVehicleChanges", function(data)
	-- if data.stolen then data.stolen = 1 else data.stolen = 0 end
	-- local usource = source
	-- MySQL.Async.fetchAll('SELECT * FROM `vehicle_mdt` WHERE `plate` = @plate', {
	-- 	['@plate'] = plate
	-- }, function(result)
	-- 	if result[1] then
	-- 		MySQL.Async.execute('UPDATE `vehicle_mdt` SET `stolen` = @stolen, `notes` = @notes WHERE `plate` = @plate', {
	-- 			['@plate'] = data.plate,
	-- 			['@stolen'] = data.stolen,
	-- 			['@notes'] = data.notes
	-- 		})
	-- 	else
	-- 		MySQL.Async.insert('INSERT INTO `vehicle_mdt` (`plate`, `stolen`, `notes`) VALUES (@plate, @stolen, @notes)', {
	-- 			['@plate'] = data.plate,
	-- 			['@stolen'] = data.stolen,
	-- 			['@notes'] = data.notes
	-- 		})
	-- 	end
		
	-- 	TriggerClientEvent("mdt:sendNotification", usource, "Vehicle changes have been saved.")
	-- end)

	print("Acest event a fost dezactivat temporar - WIP #9")
end)

function vRPmdt._getOfiteri()
	local player = source;

	local filtered_ofiteri = {};
	for k,v in pairs(userSources) do
		filtered_ofiteri[#filtered_ofiteri+1] = {
			name = playerIdentities[k].firstname.." "..playerIdentities[k].name,
			grad = vRP.getFactionRank{k},
			callsign = math.random(1,100),
		};
	end
	TriggerClientEvent('sx_mdt:returnedOfiteri', player, filtered_ofiteri);
end

-- function GetLicenses(identifier, cb)
-- 	return {};
-- end

function GetCharacterName(source)
	if source then
		local user_id = vRP.getUserId{source};
		if user_id then
			local p = promise.new();
			vRP.getUserIdentity{user_id,function(identity)
				p:resolve(identity);
			end}
			local identity = Citizen.Await(p);

			
			return ("%s %s"):format(identity.firstName, identity.lastName);
		end
		return nil;
	end
	return nil;
end